package api

type APICredentials struct {
    User        string  `json:"user"`
    Password    string  `json:"password"`
}

type APIData interface{}

type APIMeta struct {
    Count   int64   `json:"count"`
    Page    int64   `json:"page"`
}

type APIError struct {
    Message string  `json:"message"`
    Code    int64   `json:"code"`
}

type APIResponse struct {
    Data    APIData     `json:"data,omitempty"`
    Meta    *APIMeta     `json:"meta,omitempty"`
    Error   *APIError    `json:"error,omitempty"`
}
