package db

import (
    log "github.com/sirupsen/logrus"

    "reichard.io/imagini/graph/model"
)

func (dbm *DBManager) CreateMediaItem (mediaItem *model.MediaItem) error {
    log.Info("[db] Creating media item: ", mediaItem.FileName)
    err := dbm.db.Create(&mediaItem).Error
    return err
}

func (dbm *DBManager) MediaItems(mediaItemFilter *model.MediaItem) ([]model.MediaItem, int64, error) {
    var mediaItems []model.MediaItem
    var count int64

    err := dbm.db.Where(&mediaItemFilter).Find(&mediaItems).Count(&count).Error;
    return mediaItems, count, err
}
